; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm     ; the macro file

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------
      TranslateMessagex PROTO :DWORD
      DispatchMessagex  PROTO :DWORD
      GetMessagex       PROTO :DWORD,:DWORD,:DWORD,:DWORD

      .data?
        hInstance dd ?

      .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    .if reason == DLL_PROCESS_ATTACH
      push instance
      pop hInstance
      mov eax, TRUE

    .elseif reason == DLL_PROCESS_DETACH

    .elseif reason == DLL_THREAD_ATTACH

    .elseif reason == DLL_THREAD_DETACH

    .endif

    ret

LibMain endp

; 

align 4

TranslateMessagex proc mstruct:DWORD

    mov eax, mstruct

    mov ecx, (MSG PTR [eax]).hwnd
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).wParam
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).time
    mov edx, (MSG PTR [eax]).pt.x

    ret

TranslateMessagex endp

; 

align 4

DispatchMessagex proc mstruct:DWORD

    mov eax, mstruct

    mov ecx, (MSG PTR [eax]).hwnd
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).wParam
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).time
    mov edx, (MSG PTR [eax]).pt.x

    ret

DispatchMessagex endp

; 

align 4

GetMessagex proc mstruct:DWORD,arg1:DWORD,arg2:DWORD,arg3:DWORD

    push ebx
    push esi
    push edi

    mov eax, mstruct

    mov ecx, (MSG PTR [eax]).hwnd
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).wParam
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).time
    mov edx, (MSG PTR [eax]).pt.x

    mov ebx, arg1
    mov esi, arg2
    mov edi, arg3

    pop edi
    pop esi
    pop ebx

    ret

GetMessagex endp

; 

end LibMain
